/*
 *
 *  Created on: Mar 1, 2021
 *      Author: astrisw
 */

#ifndef KAFKAPROVIDER_H_
#define KAFKAPROVIDER_H_

#include <cppkafka/cppkafka.h>
#include <cppkafka/utils/buffered_producer.h>
#include <cppkafka/configuration.h>
#include <Base_Provider.h>
#include <unordered_map>


using namespace cppkafka;
class KafkaProvider : public BaseProvider{
private:
	Configuration config;
	BufferedProducer<std::string> *producer;
	std::unordered_map<std::string, MessageBuilder *> builders;
	std::string brokerIp;
	std::string brokerPort;
	std::string & topic = *(&this->dest);

	void setDest(std::string dest){setTopic(dest);}
	std::string getDest(){return getTopic();}


public:
	KafkaProvider();
	KafkaProvider(std::string ip, int port, std::string topic);

	void setBrokerIp(std::string ip){this->brokerIp=ip;}
	void setBrokerPort(std::string port){this->brokerPort=port;}
	void setTopic(std::string topic);


	std::string getBrokerIp(){return this->brokerIp;}
	std::string getBrokerPort(){return this->brokerPort;}
	std::string getTopic(){return this->topic;}

	int write(BasePacket &);
	int write(BasePacket &, std::string dest);
	int close();
	int open();
	~KafkaProvider(){
		std::cout << "Deleting Kafka provider" << std::endl;
		// delete builders; Actually the messageBuilders of the map TODO
		delete producer;
	}

};

#endif /* KAFKAPROVIDER_H_ */
